"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var resourceService_1 = require("../../services/resourceService");
var azureBasePlugin_1 = require("../azureBasePlugin");
var utils_1 = require("../../shared/utils");
var constants_1 = require("../../shared/constants");
var AzureRemovePlugin = /** @class */ (function (_super) {
    __extends(AzureRemovePlugin, _super);
    function AzureRemovePlugin(serverless, options) {
        var _this = _super.call(this, serverless, options) || this;
        _this.commands = {
            remove: {
                usage: "Remove service resource group (USE WITH CAUTION)",
                lifecycleEvents: [
                    "remove"
                ],
                options: __assign({}, constants_1.constants.deployedServiceOptions, { force: {
                        usage: "Force remove resource group without additional prompt"
                    } })
            }
        };
        _this.hooks = {
            "remove:remove": _this.remove.bind(_this)
        };
        return _this;
    }
    AzureRemovePlugin.prototype.remove = function () {
        return __awaiter(this, void 0, void 0, function () {
            var resourceService, rg, rgName, okToDelete, input;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        resourceService = new resourceService_1.ResourceService(this.serverless, this.options);
                        return [4 /*yield*/, resourceService.getResourceGroup()];
                    case 1:
                        rg = _a.sent();
                        rgName = resourceService.getResourceGroupName();
                        if (!rg) {
                            this.log("Resource group \"" + rgName + "\" does not exist in your Azure subscription");
                            return [2 /*return*/];
                        }
                        okToDelete = this.getOption("force") !== undefined;
                        if (!!okToDelete) return [3 /*break*/, 3];
                        this.log("This command will delete your ENTIRE resource group (" + resourceService.getResourceGroupName() + "). " +
                            "and ALL the Azure resources that it contains " +
                            "Are you sure you want to proceed? If so, enter the full name of the resource group :");
                        return [4 /*yield*/, utils_1.Utils.waitForUserInput()];
                    case 2:
                        input = _a.sent();
                        okToDelete = input === resourceService.getResourceGroupName();
                        _a.label = 3;
                    case 3:
                        if (!okToDelete) return [3 /*break*/, 6];
                        this.log("Deleting resource group");
                        return [4 /*yield*/, resourceService.deleteDeployment()];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, resourceService.deleteResourceGroup()];
                    case 5:
                        _a.sent();
                        this.log("Service successfully removed");
                        return [3 /*break*/, 7];
                    case 6:
                        this.log("Will not remove resource group.");
                        return [2 /*return*/];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    return AzureRemovePlugin;
}(azureBasePlugin_1.AzureBasePlugin));
exports.AzureRemovePlugin = AzureRemovePlugin;
