"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var util_1 = require("util");
var zip_folder_1 = __importDefault(require("zip-folder"));
var constants_1 = require("../shared/constants");
var utils_1 = require("../shared/utils");
var baseService_1 = require("./baseService");
var zip = util_1.promisify(zip_folder_1.default);
var CompilerService = /** @class */ (function (_super) {
    __extends(CompilerService, _super);
    function CompilerService(serverless, options) {
        return _super.call(this, serverless, options, false) || this;
    }
    CompilerService.prototype.build = function (mode) {
        return __awaiter(this, void 0, void 0, function () {
            var runtime, _a, command, args, cwd, serverlessDir;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        runtime = this.config.provider.runtime;
                        _a = this.configService.getCompilerCommand(runtime, mode), command = _a.command, args = _a.args;
                        // Spawn build process
                        return [4 /*yield*/, utils_1.Utils.spawn({
                                serverless: this.serverless,
                                command: command,
                                commandArgs: args,
                            })];
                    case 1:
                        // Spawn build process
                        _b.sent();
                        cwd = process.cwd();
                        serverlessDir = path_1.default.join(cwd, ".serverless");
                        if (!fs_1.default.existsSync(serverlessDir)) {
                            fs_1.default.mkdirSync(serverlessDir);
                        }
                        return [4 /*yield*/, zip(
                            // Build directory
                            path_1.default.join(process.cwd(), constants_1.constants.tmpBuildDir), 
                            // Target .zip file
                            path_1.default.join(serverlessDir, this.serviceName + ".zip"))];
                    case 2:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return CompilerService;
}(baseService_1.BaseService));
exports.CompilerService = CompilerService;
